> ## Documentation Index > Fetch the complete documentation index at: https://support.tulip.co/llms.txt > Use this file to discover all available pages before exploring further. # /api/stations/v1/station-groups > Creates a station group. ## OpenAPI ````json POST /api/stations/v1/station-groups { "openapi": "3.0.3", "info": { "title": "Tulip API", "version": "v1" }, "tags": [ { "name": "machines", "description": "An API for managing machines and their types" }, { "name": "stations", "description": "An API for managing and updating stations." }, { "name": "users", "description": "An API for managing users and their roles/permissions." } ], "paths": { "/api/stations/v1/station-groups": { "post": { "operationId": "createStationGroup", "description": "Creates a station group.", "tags": [ "stations" ], "x-tulip-visibility": "public", "requestBody": { "description": "The fields to create a station group.", "required": "true", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/CreateStationGroup" } } } }, "responses": { "200": { "description": "The station group was successfully created.\n", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/StationGroup" } } } }, "400": { "description": "An error occurred. The Tulip error codes `generic.customerIdRequired`, `generic.workspaceIdRequired`, `generic.invalidParams`, `http.invalidBodyJson`, `http.invalidHeaders`, and `http.multiValueHeader` all use the 400 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip customer context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.customerIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip workspace context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.workspaceIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request parameters were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.invalidParams" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request body could not be decoded as JSON.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidBodyJson" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request headers were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidHeaders" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An HTTP request header contained multiple values.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.multiValueHeader" ] }, "details": { "type": "object", "properties": { "headerName": { "description": "The name of the given HTTP header which had multiple values.\n", "type": "string" } }, "required": [ "headerName" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } ] } } } }, "401": { "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.authRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "404": { "description": "The requested resource was not found.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The requested resource was not found.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.notFound" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "409": { "description": "Resource with this name already exists in the workspace.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "Resource with this name already exists in the workspace.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.resourceWithThisNameAlreadyExists" ] }, "details": { "type": "object", "properties": { "name": { "type": "string" }, "type": { "type": "string" } }, "required": [ "name", "type" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } } } }, "422": { "description": "An error occurred. The Tulip error codes `generic.resourceLimitInWorkspaceReached`, `stations.invalidReferencedResourceId`, `stations.invalidResourceDescription`, and `stations.invalidResourceName` all use the 422 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The number of resources of the resource type in a workspace has reached the allowed limit.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.resourceLimitInWorkspaceReached" ] }, "details": { "type": "object", "properties": { "workspaceId": { "type": "string" }, "resourceType": { "type": "string" }, "limit": { "type": "number", "description": "The limit of how many resources of the type can be in the workspace." }, "current": { "type": "number", "description": "The current number of resource of the type in the workspace." } }, "required": [ "workspaceId", "resourceType" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "One or more ids referenced resources that were invalid. Please make sure\nall ids reference resources that exist.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.invalidReferencedResourceId" ] }, "details": { "type": "array", "description": "A list of invalid referenced resources.\n", "items": { "type": "object", "properties": { "resourceId": { "description": "The id of the invalid resource.\n", "type": "string" }, "details": { "description": "Details about why the resource was invalid.\n", "type": "string" } }, "required": [ "resourceId" ] } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The resource description is not valid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.invalidResourceDescription" ] }, "details": { "type": "object", "properties": { "reason": { "type": "string" } }, "required": [ "reason" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The resource name is not valid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.invalidResourceName" ] }, "details": { "type": "object", "properties": { "reason": { "type": "string" } }, "required": [ "reason" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } ] } } } }, "429": { "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.endpointRateLimitExceeded" ] }, "details": { "type": "object", "properties": { "details": { "description": "Additional details about this endpoint's rate limits.\n", "type": "string" } } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } } } }, "500": { "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.internal" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } } } } } }, "components": { "schemas": { "CreateStationGroup": { "type": "object", "description": "Used to create a station group.\n", "properties": { "name": { "type": "string", "description": "The name of the station group.\n", "maxLength": "500" }, "description": { "type": "string", "description": "A short description of the station group.\n", "maxLength": "5000" }, "appAssignments": { "type": "array", "description": "The station group's app assignments. Stations within this group\nwill inherit these assignments.\n", "items": { "$ref": "#/components/schemas/GenericAppAssignment" } } }, "required": [ "name" ], "example": { "name": "Boston", "description": "Contains all the stations in the Boston factory.", "appAssignments": [ { "type": "app-folder", "tag": "latest-published", "appFolderId": "swM2aGebq5MjhKafN" } ] } }, "StationGroup": { "type": "object", "description": "Represents a station group.\n", "properties": { "id": { "$ref": "#/components/schemas/StationGroupId" }, "name": { "type": "string", "description": "The name of the station group.\n" }, "parentId": { "allOf": [ { "$ref": "#/components/schemas/StationGroupId" }, { "description": "The station group may be part of another Station Group.\n" } ] }, "description": { "type": "string", "description": "A short description of the station group.\n" }, "created": { "$ref": "#/components/schemas/Created" }, "lastModified": { "$ref": "#/components/schemas/LastModified" }, "archived": { "$ref": "#/components/schemas/Archived" }, "workspaces": { "$ref": "#/components/schemas/WorkspaceMembership" } }, "required": [ "id", "name", "appAssignments", "created", "lastModified", "workspaces" ], "example": { "id": "swM2aGebq5MjhKafN", "name": "Boston", "description": "Contains all the stations in the Boston factory.", "appAssignments": [ { "id": "78M2aGebq5MjhKafN", "type": "app-folder", "tag": "latest-published", "appFolderId": "12M2aGebq5MjhKafN" } ], "created": { "at": "2023-03-08T12:17:24Z", "by": { "id": "90M2aGebq5MjhKafN", "type": "user" } }, "lastModified": { "at": "2023-03-08T12:17:24Z", "by": { "id": "90M2aGebq5MjhKafN", "type": "user" } }, "workspaces": { "scope": "specific", "workspaceIds": [ "56M2aGebq5MjhKafN" ] } } }, "ApiError": { "description": "An error response returned by a Tulip API.\n", "type": "object", "properties": { "errorCode": { "description": "A machine-readable code identifying the type of error.\n", "type": "string", "pattern": "^[a-zA-Z0-9.]$" }, "message": { "description": "A human-readable description of the error intended for debugging purposes only.\n\nThe exact content of this message is not stable.\n", "type": "string" }, "retryable": { "description": "Whether the request can be automatically retried by the client.\n", "type": "boolean" } }, "required": [ "errorCode", "retryable" ] }, "GenericAppAssignment": { "type": "object", "description": "Represents the contents of a single app assignment.\n", "oneOf": [ { "$ref": "#/components/schemas/AllAppAssignment" }, { "$ref": "#/components/schemas/FolderAppAssignment" }, { "$ref": "#/components/schemas/SpecificAppAssignment" }, { "$ref": "#/components/schemas/VersionAppAssignment" } ], "discriminator": { "propertyName": "type", "mapping": { "all": "#/components/schemas/AllAppAssignment", "app-folder": "#/components/schemas/FolderAppAssignment", "app": "#/components/schemas/SpecificAppAssignment", "app-version": "#/components/schemas/VersionAppAssignment" } }, "example": { "type": "app", "tag": "development", "appId": "swM2aGebq5MjhKafN" } }, "StationGroupId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of a station group.\n" } ] }, "Created": { "allOf": [ { "$ref": "#/components/schemas/CRUDMetadata" }, { "description": "When and by whom a resource was created.\n", "required": [ "at" ] } ] }, "LastModified": { "allOf": [ { "$ref": "#/components/schemas/CRUDMetadata" }, { "description": "When and by whom a resource was last modified.\n", "required": [ "at", "by" ] } ] }, "Archived": { "allOf": [ { "$ref": "#/components/schemas/CRUDMetadata" }, { "description": "When and by whom a resource was archived. This field will be absent if and only if the\nresource is not currently archived.\n", "required": [ "at", "by" ] } ] }, "WorkspaceMembership": { "description": "A description of the workspaces of which a resource is a member. Workspace membership can\nhave one of two `scope` values. A `scope` of `all` means that a resource is a member of all\ncurrent and future workspaces. A `scope` of the value `specific` means that a resource is a\nmember of a set of particular workspaces as described by the `workspaceIds` property.\n", "type": "object", "required": [ "scope" ], "properties": { "scope": { "description": "Whether or not a resource is a member of a set of specific workspaces or all current and future workspaces.\n", "type": "string", "enum": [ "all", "specific" ] } }, "oneOf": [ { "$ref": "#/components/schemas/AllWorkspacesMembership" }, { "$ref": "#/components/schemas/SpecificWorkspacesMembership" } ], "discriminator": { "propertyName": "scope", "mapping": { "all": "#/components/schemas/AllWorkspacesMembership", "specific": "#/components/schemas/SpecificWorkspacesMembership" } }, "example": { "scope": "specific", "workspaceIds": [ "DEFAULT" ] } }, "AllAppAssignment": { "type": "object", "description": "Allows all apps to be assigned to a station or station group.\n", "properties": { "type": { "type": "string", "default": "all", "enum": [ "all" ] }, "tag": { "$ref": "#/components/schemas/AppAssignmentTag" } }, "required": [ "type", "tag" ], "example": { "type": "all", "tag": "development" } }, "FolderAppAssignment": { "type": "object", "description": "Describes a folder of apps that are assigned to a station or station group.\n", "properties": { "type": { "type": "string", "default": "app-folder", "enum": [ "app-folder" ] }, "tag": { "$ref": "#/components/schemas/AppAssignmentTag" }, "appFolderId": { "$ref": "#/components/schemas/AppFolderId" } }, "required": [ "type", "tag", "appFolderId" ], "example": { "type": "app-folder", "tag": "development", "appFolderId": "swM2aGebq5MjhKafN" } }, "SpecificAppAssignment": { "type": "object", "description": "Describes a specific app that is assigned to a station or station group.\n", "properties": { "type": { "type": "string", "default": "app", "enum": [ "app" ] }, "tag": { "$ref": "#/components/schemas/AppAssignmentTag" }, "appId": { "$ref": "#/components/schemas/AppId" } }, "required": [ "type", "tag", "appId" ], "example": { "type": "app", "tag": "development", "appId": "swM2aGebq5MjhKafN" } }, "VersionAppAssignment": { "type": "object", "description": "Describes a specific app version that is assigned to a station or station group. Only published\napp versions can be used in app assignments.\n", "properties": { "type": { "type": "string", "default": "app-version", "enum": [ "app-version" ] }, "appVersionId": { "$ref": "#/components/schemas/AppVersionId" }, "appId": { "$ref": "#/components/schemas/AppId" } }, "required": [ "type", "appVersionId", "appId" ], "example": { "type": "app-version", "appVersionId": "swM2aGebq5MjhKafN", "appId": "12M2aGebq5MjhKafN" } }, "RandomId": { "description": "A randomly generated unique identifier.\n\nTypically has ~98 bits of entropy.\n", "example": "g56RCoZCtzv7borvp", "type": "string", "pattern": "^[a-zA-Z0-9_]+$" }, "CRUDMetadata": { "description": "When and by whom an action was performed on a resource.\n", "type": "object", "properties": { "at": { "$ref": "#/components/schemas/DateTime" }, "by": { "$ref": "#/components/schemas/ActorMetadata" } } }, "AllWorkspacesMembership": { "type": "object", "properties": { "scope": { "description": "Describes a resource as a member of all current and future workspaces.\n", "type": "string", "enum": [ "all" ], "example": "all" } }, "required": [ "scope" ] }, "SpecificWorkspacesMembership": { "type": "object", "properties": { "scope": { "description": "Describes a resource as a member of a set of specific workspaces.\n", "type": "string", "enum": [ "specific" ], "example": "specific" }, "workspaceIds": { "description": "The workspaces in which a resource is a member.\n", "type": "array", "items": { "$ref": "#/components/schemas/WorkspaceId" } } }, "required": [ "scope", "workspaceIds" ] }, "AppAssignmentTag": { "description": "The tag of an app assignment. Determines if the app assignment refers\nto the development version of an app or the latest production version.\n", "type": "string", "enum": [ "development", "latest-published" ] }, "AppFolderId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "A random string which uniquely identifies an app folder.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app folder.\n" } ] }, "AppId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The unique identifier for an app.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app.\n" } ] }, "AppVersionId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The unique identifier for an app version.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app version.\n" } ] }, "DateTime": { "description": "A date-time string as defined by\n[RFC 3339 ยง5.6](https://tools.ietf.org/html/rfc3339#section-5.6).\n", "example": "2022-11-21T19:59:10+00:00", "type": "string", "format": "date-time" }, "ActorMetadata": { "description": "Represents a user, api-token, or device.\n", "type": "object", "properties": { "type": { "$ref": "#/components/schemas/ActorType" }, "id": { "$ref": "#/components/schemas/UserId" } }, "required": [ "type", "id" ] }, "WorkspaceId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The ID of a Tulip Workspace.\n", "example": "DEFAULT", "type": "string" } ] }, "ActorType": { "description": "The type of actor performing an action.\n", "type": "string", "enum": [ "user", "client", "api-token", "app-exchange-api-token", "celosx-api-token", "automation", "instance-init", "scim", "unknown" ] }, "UserId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The ID of a Tulip User.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "A random string which uniquely identifies a user.\n" } ] } } } } ````